import QtQuick 1.1

Rectangle {
    id: gkosButton

    property alias label: button_text.text
    property alias fontSize: button_text.font.pixelSize
    property alias fontColor: button_text.color
    property alias keyState: gkosButton.state
    property alias keyImage: mainButton.source
    property alias keyGraph: buttonGraph.source


    border.color: "black"
    border.width: 1
            Image {
                id: mainButton
                source: "images/mainButtonBlue.png"
                anchors.fill: parent
                Image {
                    id: buttonGraph
                    // source: ""
                    anchors.centerIn: parent
                }

            }

// Different states for main buttons, middle buttons and bar buttons:

states: [
    State {
        name: "up"
   PropertyChanges { target: mainButton; source: themeMainButton }
   // PropertyChanges { target: buttonGraph; source: keyGraph;}
    },
    State {
        name: "upMiddle"
   PropertyChanges { target: mainButton; source: themeMiddleButton }
   // PropertyChanges { target: buttonGraph; source: keyGraph;}
    },
    State {
        name: "upTop"
   PropertyChanges { target: mainButton; source: themeTopButton }
   // PropertyChanges { target: buttonGraph; source: keyGraph;}
    },
    State {
        name: "upBar"
   PropertyChanges { target: mainButton; source: themeBarButton }
   // PropertyChanges { target: buttonGraph; source: keyGraph;}
    },
    State {
        name: "upLeftBar"
   PropertyChanges { target: mainButton; source: themeLeftBarButton }
   // PropertyChanges { target: buttonGraph; source: keyGraph;}
    },
    State {
        name: "upSmall"
    PropertyChanges { target: mainButton; source: "images/smallButton.png" }
    PropertyChanges { target: buttonGraph; source: "";}
    },
    State {
        name: "down"
    PropertyChanges { target: mainButton; source: "images/mainButtonPressed.png" }
    // PropertyChanges { target: buttonGraph; source: "";}
    }
]

// transition is unfinished, possibly not needed at all, because states take care of it

transitions: [
    Transition {
    from: "up"; to: "down"
    }
]

Text {
    anchors.centerIn: parent
            id: button_text
    // font.pixelSize: 22
     text: "0"
}



}
