
// file id: GHandler

function randomNumber(from, to) { // for random location of the night clock
   return Math.floor(Math.random() * (to - from + 1) + from);
}

// set all

function setKeyboard(state, key, offset) {

    //                           aux  Aux  AUX
    // 0,   64,  128, 192, 256,  320, 384, 448
    // abc, Abc, ABC, 123, SYMB, Hangul (한글)

    if ((useAuxSets) && (offset < 128)){
        offset += 320;
    }
    if ((!useAuxSets) && (offset > 256)){
        offset += -320;
    }

    setHelpers(state, key, offset);
    // Highligts:
    keyboardStatus(state, key); // update downA...downSP
     // Characters:
    setLabels(state, key, offset)
     // Graphics:
    setGraphs(state, key, offset)
}


// what image is shown on the keys

function setGraphs(state, key, gOffset){


    if (!showSymbs) {
        graphA=""; graphB=""; graphC=""; graphO=""; graphS=""; graphTH=""; graphBS = "";
        graphD=""; graphE=""; graphF=""; graphG=""; graphK=""; graphW=""; graphSP = "";
        return;
    }

    gOffset = 0; // Use same graphs always
    var n = 0;
    var m = 0;

    if ((state > 0) && (state < 8)){m = state;} // GSets.gChordToRef[state] }
    if ((state > 7) && (state < 57)){n = state;} // GSets.gChordToRef[state] }

    // Left pad
    if ((state > 0) && (state < 8)){graphA=""; graphB=""; graphC=""; graphO=""; graphS="";
        graphTH=""; graphBS=""; graphAbc = "";} else {
        graphA = GSets.GKOSGraphs[GSets.gChordToRef[1 + n] + gOffset];
        graphB = GSets.GKOSGraphs[GSets.gChordToRef[2 + n] + gOffset];
        graphC = GSets.GKOSGraphs[GSets.gChordToRef[4 + n] + gOffset];
        graphO = GSets.GKOSGraphs[GSets.gChordToRef[3 + n] + gOffset];
        graphS = GSets.GKOSGraphs[GSets.gChordToRef[6 + n] + gOffset];
        graphTH = GSets.GKOSGraphs[GSets.gChordToRef[5 + n] + gOffset];
        graphBS = GSets.GKOSGraphs[GSets.gChordToRef[7 + n] + gOffset];
        graphAbc = "";
    }

    // Right pad
    if ((state > 7) && (state < 57)){graphD=""; graphE=""; graphF=""; graphG=""; graphK="";
        graphW=""; graphSP=""; graphTools = ""} else {
        graphD = GSets.GKOSGraphs[GSets.gChordToRef[8 + m] + gOffset];
        graphE = GSets.GKOSGraphs[GSets.gChordToRef[16 + m] + gOffset];
        graphF = GSets.GKOSGraphs[GSets.gChordToRef[32 + m] + gOffset];
        graphG = GSets.GKOSGraphs[GSets.gChordToRef[24 + m] + gOffset];
        graphK = GSets.GKOSGraphs[GSets.gChordToRef[48 + m] + gOffset];
        graphW = GSets.GKOSGraphs[GSets.gChordToRef[40 + m] + gOffset];
        graphSP = GSets.GKOSGraphs[GSets.gChordToRef[56 + m] + gOffset];
        graphTools = "";
    }

    // if ((state > 7) && (state < 57)){graphD=""; graphE=""; graphF=""; graphG=""; graphK=""; graphW=""; graphSP="";}

    if ((state === 0) && (key === 0)){
        graphA=""; graphB=""; graphC=""; graphO=""; graphS=""; graphTH=""; graphBS = GSets.GKOSGraphs[GSets.gChordToRef[7 + n] + gOffset];
        graphD=""; graphE=""; graphF=""; graphG=""; graphK=""; graphW=""; graphSP = GSets.GKOSGraphs[GSets.gChordToRef[56] + gOffset];
    }

    return;
}



// what character is shown on the keys

function setLabels(state, key, gOffset){

    // a, Abc ABC  123  SYMB aux  Aux  AUX
    // 0, 64, 128, 192, 256, 320, 384, 448

    // var gOffset = 0;


    labelLang = GSets.languageIndication[gLanguage];
    if (useAuxSets) {labelLang = GSets.languageIndication[0];} // Engish

    switch(gOffset){

    case 0:
        labelAbc = "abc";
        break;

    case 64:
        labelAbc = "Abc";
        break;

    case 128:
        labelAbc = "ABC";
        break;

    case 192:
        labelAbc = "123";
        break;

    case 256:
        labelAbc = ":#@";
        break;

    case 320:
        labelAbc = auxLabel1;
        break;

    case 384:
        labelAbc = auxLabel2;
        break;

    case 448:
        labelAbc = "AUX";
        break;

    default:

        labelAbc = "???";
        break;

    }

    if (!showSymbs){ // hide all symbols on keys in Maste Mode
        labelA=""; labelB=""; labelC=""; labelO=""; labelS="";
        labelTH=""; labelBS="";
        labelD="";  labelE="";  labelF="";  labelG="";  labelK="";
        labelW="";  labelSP="";  labelTools = "Tools"
        return;
    }

    var n = 0;
    var m = 0;

    if ((state > 0) && (state < 8)){m = state;} // GSets.gChordToRef[state] }
    if ((state > 7) && (state < 57)){n = state;} // GSets.gChordToRef[state] }

    // Left pad
    if ((state > 0) && (state < 8)){labelA=""; labelB=""; labelC=""; labelO=""; labelS="";
        labelTH=""; labelBS="";} else {
        labelA = GSets.GKOSChars[GSets.gChordToRef[1 + n] + gOffset]; if ((labelA.charAt(0) == "_") &&  (labelA != "_")) {labelA = "";}
        labelB = GSets.GKOSChars[GSets.gChordToRef[2 + n] + gOffset]; if  (labelB.charAt(0) == "_") {labelB = "";}
        labelC = GSets.GKOSChars[GSets.gChordToRef[4 + n] + gOffset]; if  (labelC.charAt(0) == "_") {labelC = "";}
        labelO = GSets.GKOSChars[GSets.gChordToRef[3 + n] + gOffset]; if  (labelO.charAt(0) == "_") {labelO = labelO.substring(1);}
        labelS = GSets.GKOSChars[GSets.gChordToRef[6 + n] + gOffset]; if  (labelS.charAt(0) == "_") {labelS = labelS.substring(1);}
        labelTH = GSets.GKOSChars[GSets.gChordToRef[5 + n] + gOffset]; if  (labelTH.charAt(0) == "_") {labelTH = labelTH.substring(1);}
        labelBS = GSets.GKOSChars[GSets.gChordToRef[7 + n] + gOffset]; if  (labelBS.charAt(0) == "_") {labelBS = "";}
        // if (gOffset == 320) {labelAbc = auxLabel1;} else { if (gOffset == 384){labelAbc = auxLabel2}};
        if (labelA.length > 6){smallA = 2;} else {smallA = 0;}
        if (labelS.length > 4){smallS = 1;} else {smallS = 0;}
    }

    // Right pad
    if ((state > 7) && (state < 57)){ labelD="";  labelE="";  labelF="";  labelG="";  labelK="";
         labelW="";  labelSP="";  labelTools = "Tools";} else {
        labelD = GSets.GKOSChars[GSets.gChordToRef[8 + m] + gOffset]; if  (labelD.charAt(0) == "_") {labelD = "";}
        labelE = GSets.GKOSChars[GSets.gChordToRef[16 + m] + gOffset]; if ((labelE.charAt(0) == "_") &&  (labelE != "_")) {labelE = "";}
        labelF = GSets.GKOSChars[GSets.gChordToRef[32 + m] + gOffset]; if  (labelF.charAt(0) == "_") {labelF = "";}
        labelG = GSets.GKOSChars[GSets.gChordToRef[24 + m] + gOffset]; if  (labelG.charAt(0) == "_") {labelG = labelG.substring(1);}
        labelK = GSets.GKOSChars[GSets.gChordToRef[48 + m] + gOffset]; if  (labelK.charAt(0) == "_") {labelK = labelK.substring(1);}
        labelW = GSets.GKOSChars[GSets.gChordToRef[40 + m] + gOffset]; if  (labelW.charAt(0) == "_") {labelW = labelW.substring(1);}
        labelSP = GSets.GKOSChars[GSets.gChordToRef[56 + m] + gOffset]; if  (labelSP.charAt(0) == "_") {labelSP = "";}
        labelTools = "Tools";
        if (labelE.length > 4){smallE = 1;} else {smallE = 0;}
        if (labelW.length > 4){smallW = 1;} else {smallW = 0;}
    }

   //  if ((state > 7) && (state < 57)) {labelD=""; labelE=""; labelF=""; labelG=""; labelK=""; labelW=""; labelSP="";}


    // Hide middle key characters when a, b, c, d, e or f pressed
    if ((state == 1) || (state == 2) || (state == 4))  {labelW = ""; labelG = ""; labelK = "";} else {
        if ((state == 8) || (state == 16) || (state == 32))  {labelTH = ""; labelO = ""; labelS = "";}
    }

    return;
}


function setHelpers(state, key, gOffset){

    //  text for translation is qsTr("\u2191")

    if (!showSymbs){
        helperA = ""; helperO = ""; helperTH = "";
        helperD = ""; helperG = ""; helperW = "";
        return;
    }

    if ((state !== 0) || (key !== 0) || !showHelp){
        helperA = ""; helperO = ""; helperTH = "";
        helperD = ""; helperG = ""; helperW = "";


    	if (!helpersOn){return;}

	if (state < 8){
	
        var hG1 = GSets.GKOSChars[GSets.gChordToRef[24 + 1] + gOffset]; if (hG1.length > 1){hG1 = " ";} // the
	    var hG2 = GSets.GKOSChars[GSets.gChordToRef[24 + 2] + gOffset];
	    var hG3 = GSets.GKOSChars[GSets.gChordToRef[24 + 4] + gOffset];
        var hG4 = GSets.GKOSChars[GSets.gChordToRef[48 + 1] + gOffset]; if (hG4.length > 1){hG4 = " ";} // apakah
	    var hG5 = GSets.GKOSChars[GSets.gChordToRef[48 + 2] + gOffset];
	    var hG6 = GSets.GKOSChars[GSets.gChordToRef[48 + 4] + gOffset];
	
	    var hW1 = GSets.GKOSChars[GSets.gChordToRef[40 + 1] + gOffset]; // if (hW1.length > 2){hW1 = "\n";}
	    var hW2 = GSets.GKOSChars[GSets.gChordToRef[40 + 2] + gOffset]; // if (hW2.length > 2){hW2 = "\n";}
	    var hW2b = GSets.GKOSChars[GSets.gChordToRef[40 + 6] + gOffset] + "\n"; if (hW2b.length > 2){hW2b = "";}
	    var hW3 = GSets.GKOSChars[GSets.gChordToRef[40 + 4] + gOffset];// if (hW3.length > 1){hW3 = "";}

	} else {

	    var hO1 = GSets.GKOSChars[GSets.gChordToRef[11] + gOffset];
	    var hO2 = GSets.GKOSChars[GSets.gChordToRef[19] + gOffset];
	    var hO3 = GSets.GKOSChars[GSets.gChordToRef[35] + gOffset];
	    var hO4 = GSets.GKOSChars[GSets.gChordToRef[14] + gOffset];
	    var hO5 = GSets.GKOSChars[GSets.gChordToRef[22] + gOffset];
	    var hO6 = GSets.GKOSChars[GSets.gChordToRef[38] + gOffset];
	
	    var hTH1 = GSets.GKOSChars[GSets.gChordToRef[5 + 8] + gOffset] + " "; if (hTH1.length > 2){hTH1 = "";}
	    var hTH2 = GSets.GKOSChars[GSets.gChordToRef[5 + 16] + gOffset] + " "; if (hTH2.length > 2){hTH2 = "";}
	    var hTH2b = GSets.GKOSChars[GSets.gChordToRef[5 + 16 + 32] + gOffset] + "\n"; if (hTH2b.length > 2){hTH2b = "";}
	    var hTH3 = GSets.GKOSChars[GSets.gChordToRef[5 + 32] + gOffset]; if (hTH3.length > 1){hTH3 = "";}

	}


        
	switch (state) {

	case 1:
                helperG = hG1 + "\n" + " " + "\n" + " " + "\n\n\n\n" + hG4 + "\n" + " " + "\n" + " ";
		helperW = hW1 + "\n" + " " + "\n" + " " + " ";
		break;
	case 2:
            helperG = " " + "\n" + hG2 + "\n" + " " + "\n\n\n\n" + " " + "\n" + hG5 + "\n" + " ";
		helperW = " " + "\n" + hW2 + "\n" + " " + " ";
		break;
	case 4:
                helperG = " " + "\n" + " " + "\n" + hG3 + "\n\n\n\n" + " " + "\n" + " " + "\n" + hG6;
		helperW = " " + "\n" + " " + "\n" + " " + hW3;
		break;

	case 8:
                helperO = hO1 + "\n" + " " + "\n" + " " + "\n\n\n\n" + hO4 + "\n" + " " + "\n" + " ";
                helperTH = hTH1 + "\n" + " " + "\n" + " " + " ";
		break;
	case 16:
                helperO = " " + "\n" + hO2 + "\n" + " " + "\n\n\n\n" + " " + "\n" + hO5 + "\n" + " ";
                helperTH = " " + "\n" + hTH2 + "\n" + " " + " ";
		break;
	case 32:
                helperO = " " + "\n" + " " + "\n" + hO3 + "\n\n\n\n" + " " + "\n" + " " + "\n" + hO6;
                helperTH = " " + "\n" + " " + "\n" + " " + hTH3;
		break;


	default:
		helperA = ""; helperO = ""; helperTH = "";
        	helperD = ""; helperG = ""; helperW = "";
		break;

	}

	return;

    } // key(s) pressed


	// Nothing pressed:


    	if (!helpersOn){return;}


    // Left pad:
    // helperA = "\u2191\n-\n\n\n\n\n\u21e7\n.\n\n\n!\n\u2193"; // hA1, hA2, hA3, hA4, hA5, hA6
    var hA1 = "\u2191";
    var hA2 = GSets.GKOSChars[GSets.gChordToRef[17] + gOffset];
    var hA3 = "\u21e7";
    var hA4 = GSets.GKOSChars[GSets.gChordToRef[34] + gOffset];
    var hA5 = GSets.GKOSChars[GSets.gChordToRef[12] + gOffset];
    var hA6 = "\u2193";
    helperA = hA1 + " \n" + hA2 + " \n\n\n\n" + hA3 + " \n" + hA4 + " \n\n\n\n" + hA5 + " \n" + hA6;

    // helperO = "p\nq\nr\n\n\n\n\nt\nu\nv"; // hO1, hO2, hO3, hO4, hO5, hO6
        hO1 = GSets.GKOSChars[GSets.gChordToRef[11] + gOffset];
        hO2 = GSets.GKOSChars[GSets.gChordToRef[19] + gOffset];
        hO3 = GSets.GKOSChars[GSets.gChordToRef[35] + gOffset];
        hO4 = GSets.GKOSChars[GSets.gChordToRef[14] + gOffset];
        hO5 = GSets.GKOSChars[GSets.gChordToRef[22] + gOffset];
        hO6 = GSets.GKOSChars[GSets.gChordToRef[38] + gOffset];
        helperO = hO1 + "\n" + hO2 + "\n" + hO3 + "\n\n\n\n" + hO4 + "\n" + hO5 + "\n" + hO6

    // helperTH = "å ä ö"; // hTH1, hTH2, hTH3
        hTH1 = GSets.GKOSChars[GSets.gChordToRef[5 + 8] + gOffset] + " "; if (hTH1.length > 2){hTH1 = "";}
        hTH2 = GSets.GKOSChars[GSets.gChordToRef[5 + 16] + gOffset] + " "; if (hTH2.length > 2){hTH2 = "";}
        hTH2b = GSets.GKOSChars[GSets.gChordToRef[5 + 16 + 32] + gOffset] + "\n"; if (hTH2b.length > 2){hTH2b = "";}
        hTH3 = GSets.GKOSChars[GSets.gChordToRef[5 + 32] + gOffset]; if (hTH3.length > 1){hTH3 = "";}
    helperTH = hTH1 + "\n" + hTH2 + "\n" + hTH2b + hTH3;

    // Right pad;
    // helperD = "\u2191\n'\n\n\n\n\n\u21e7\n,\n\n\n\n?\n\u2193"; // hD1, hD2, hD3, hD4, hD5, hD6
    var hD1 = "\u2191";
    var hD2 = GSets.GKOSChars[GSets.gChordToRef[10] + gOffset];
    var hD3 = "\u21e7";
    var hD4 = GSets.GKOSChars[GSets.gChordToRef[20] + gOffset];
    var hD5 = GSets.GKOSChars[GSets.gChordToRef[33] + gOffset];
    var hD6 = "\u2193";
    helperD = hD1 + " \n" + hD2 + " \n\n\n\n" + hD3 + " \n" + hD4 + " \n\n\n\n" + hD5 + " \n" + hD6;

    // helperG = "h\ni\nj\n\n\n\nl\nm\nn"; // hG1, hG2, hG3, hG4, hG5, hG6
        hG1 = GSets.GKOSChars[GSets.gChordToRef[24 + 1] + gOffset]; if (hG1.length > 1){hG1 = " ";} // the
        hG2 = GSets.GKOSChars[GSets.gChordToRef[24 + 2] + gOffset];
        hG3 = GSets.GKOSChars[GSets.gChordToRef[24 + 4] + gOffset];
        hG4 = GSets.GKOSChars[GSets.gChordToRef[48 + 1] + gOffset]; if (hG4.length > 1){hG4 = " ";} // apakah
        hG5 = GSets.GKOSChars[GSets.gChordToRef[48 + 2] + gOffset];
        hG6 = GSets.GKOSChars[GSets.gChordToRef[48 + 4] + gOffset];
        helperG = hG1 + "\n" + hG2 + "\n" + hG3 + "\n\n\n\n" + hG4 + "\n" + hG5 + "\n" + hG6

    // helperW = "x y z"; // hG1, hG2, hG3
        hW1 = GSets.GKOSChars[GSets.gChordToRef[40 + 1] + gOffset]; // if (hW1.length > 2){hW1 = "\n";}
        hW2 = GSets.GKOSChars[GSets.gChordToRef[40 + 2] + gOffset]; // if (hW2.length > 2){hW2 = "\n";}
        hW2b = GSets.GKOSChars[GSets.gChordToRef[40 + 6] + gOffset] + "\n"; if (hW2b.length > 2){hW2b = "";}
        hW3 = GSets.GKOSChars[GSets.gChordToRef[40 + 4] + gOffset];// if (hW3.length > 1){hW3 = "";}
    helperW = hW1 + "\n" + hW2 + "\n" + hW2b + hW3;

    return;
}




// for highliting the pressed keys

function keyboardStatus(state, key){

    // defaults:
    downA = 0; downB = 0; downC = 0; downD = 0; downE = 0; downF = 0;
    downG = 0; downK = 0; downO = 0; downS = 0; downTH = 0; downW = 0;
    downBS = 0; downSP = 0; downAbc = 0; downTools = 0;

    switch(state){
    case 1:
        downA = 1; break;
    case 3:
        downO = 1; downA = 1; downB = 1; break;
    case 2:
        downB = 1; break;
    case 6:
        downS = 1; downB = 1; downC = 1; break;
    case 4:
        downC = 1; break;
    case 5:
         downTH = 1; break;
    case 7:
         downBS = 1; break;

    case 8:
         downD = 1; break;
    case 24:
         downG = 1; downD = 1;  downE = 1; break;
    case 16:
        downE = 1; break;
    case 48:
         downK = 1; downE = 1;  downF = 1; break;
    case 32:
        downF = 1; break;
    case 40:
         downW = 1; break;
    case 56:
         downSP = 1; break;
    case 100:
         downAbc = 1; break
    case 101:
         downTools = 1; break


    default:
        break;
    }

        switch(key){
        case 1:
            downA = 1; break;
        case 3:
            downO = 1; downA = 1; downB = 1; break;
        case 2:
            downB = 1; break;
        case 6:
            downS = 1; downB = 1; downC = 1; break;
        case 4:
            downC = 1; break;
        case 5:
            downTH = 1; break;
        case 7:
            downBS = 1; break;

        case 8:
            downD = 1; break;
        case 24:
            downG = 1; downD = 1; downE = 1; break;
        case 16:
            downE = 1; break;
        case 48:
            downK = 1; downE = 1; downF = 1; break;
        case 32:
            downF = 1; break;
        case 40:
            downW = 1; break;
        case 56:
            downSP = 1; break;

        default:
            break;

    }

    return;

}


// Locate the touch point in the key grid

function gRead(x1, y1, x2, y2, n) {

    // return; // Test for delay difference

    // Spec of Nokia N9: Screen Resolution is 16:9, FWVGA, 854 x 480 pixels

    // Simulator was:
    // x: 0...730(right edge), y: 0...430(bottom)

    // save x, y for slide length checking in main qml
    slidePointX = landscapeOrientation ? x1 : y1
    slidePointY = landscapeOrientation ? y1 : x1


    var previousNumberOfPoints
    var gRow1, gColumn1 // Touch point 1 key
    var gRow2, gColumn2 // Touch point 2 key
    var dx, dy
    var yOffset = 0; // Both pads may move down. Landscape: 0, Portrait 854-480 = 374
    var gHeight = 480;
    var gWidth = 854; // Landscape: 730, Portrait: 430
    var gState = 0; // First key pressed
    var gKey = 0; // Second key preseed
    // var gChord = 0; // The resulting chord value

    console.log("Touch point 1: " + n + " x/y: " + x1 + "/" + y1)
    console.log("Touch point 2: " + n + " x/y: " + x2 + "/" + y2)
    console.log(" ")

    if (n < previousNumberOfPoints) {
        console.log("Release")

    }
    previousNumberOfPoints = n;


    // For Nokia N9, you get the same physcal position values in portrait and landscape,
    // so you have to compensate:
    if (!landscapeOrientation){
        var xTemp = 480 - y1;
        var yTemp = x1;
        y1 = yTemp; x1 = xTemp;
        xTemp = 480 - y2;
        yTemp = x2;
        y2 = yTemp; x2 = xTemp;
    }

    console.log("> Touch point 1: " + n + " x/y: " + x1 + "/" + y1)
    console.log("> Touch point 2: " + n + " x/y: " + x2 + "/" + y2)
    console.log(" ")


    // yOffset = pads move down while in portrait, Right pad moves towards the left one
    yOffset = landscapeOrientation ? 0 : 374 // 854-480
    gWidth = landscapeOrientation ? 854 : 480

    // Button dimensions
    dy = parseInt(gHeight/5) - 2; // 430/5 - 2 = 84
    dx = parseInt(gHeight/5); // square effective button areas

    gColumn1 = 0; // default
    if (x1 > 0) {gColumn1 = 1;}
    if (x1 > dx + 12) {gColumn1 = 2;}
    if (x1 > 2 * dx + 12) {gColumn1 = 0;} // text area might be here
    if (x1 > (gWidth - 2 * dx)) {gColumn1 = 3;}
    if (x1 > (gWidth - dx)) {gColumn1 = 4;}
    if (x1 > gWidth) {gColumn1 = 0;} // Out of screen

    gRow1 = 0; // default
    if ((y1 > 0 + yOffset) && (y1 > (gHeight - 5 * dy))){gRow1 = 1;}
    if (y1 > (gHeight - 4 * dy + yOffset)){gRow1 = 2;}
    if (y1 > (gHeight - 3 * dy + yOffset)){gRow1 = 3;}
    if (y1 > (gHeight - 2 * dy + yOffset)){gRow1 = 4;}
    if (y1 > (gHeight - dy + yOffset)){gRow1 = 5;}
    if (y1 > (gHeight + yOffset)){gRow1 = 0;} // Out of screen

    gColumn2 = 0; // default
    if (x2 > 0) {gColumn2 = 1;}
    if (x2 > dx) {gColumn2 = 2;}
    if (x2 > 2 * dx) {gColumn2 = 0;} // text area might be here
    if (x2 > (gWidth - 2 * dx - 12)) {gColumn2 = 3;}
    if (x2 > (gWidth - dx - 12)) {gColumn2 = 4;}
    if (x2 > gWidth) {gColumn2 = 0;} // Out of screen

    gRow2 = 0; // default
    if ((y2 > 0 + yOffset) && (y2 > (gHeight - 5 * dy))){gRow2 = 1;}
    if (y2 > (gHeight - 4 * dy + yOffset)){gRow2 = 2;}
    if (y2 > (gHeight - 3 * dy + yOffset)){gRow2 = 3;}
    if (y2 > (gHeight - 2 * dy + yOffset)){gRow2 = 4;}
    if (y2 > (gHeight - dy + yOffset)){gRow2 = 5;}
    if (y2 > gHeight + yOffset){gRow2 = 0;} // Out of screen

    // Make abc and Tools button areas smaller than others
    if ((gRow1 == 1) && (gColumn1 == 2)){ // abc
        if ((y1 > dy + yOffset - 20) || (x1 < (dx + 36))){gRow1 = 0; gColumn1 = 0; }
    }
    if ((gRow1 == 1) && (gColumn1 == 3)){ // Tools
        if ((y1 > dy + yOffset - 20) || (x1 > (gWidth - dx - 36))){gRow1 = 0; gColumn1 = 0; }

    }

    gState = gridToValue(gRow1, gColumn1)
    gKey = gridToValue(gRow2, gColumn2)

    //console.log("GKOS pad row/column. Touch1: " + gRow1 + "/" + gColumn1 + " Touch2: " + gRow2 + "/" + gColumn2 +  "Chord=" + gChord)

    return {gRow1:gRow1, gColumn1:gColumn1, gRow2:gRow2, gColumn2:gColumn2 , gState:gState, gKey:gKey};
}

function gridToValue(row, column){

    var keyValue

    switch (row){

    case 1:
        if (column == 1){keyValue = 1; break;}
        if (column == 2){keyValue = 100; break;} // 100 = abc button/indicator
        if (column == 3){keyValue = 101; break;} // 101 = Tools button
        if (column == 4){keyValue = 8; break;}
        if (column === 0){keyValue = 0; break;}
        break;
    case 2:
        if (column == 1){keyValue = 3; break;}
        if (column == 2){keyValue = 5; break;}
        if (column == 3){keyValue = 40; break;}
        if (column == 4){keyValue = 24; break;}
        if (column === 0){keyValue = 0; break;}
        break;
    case 3:
        if (column == 1){keyValue = 2; break;}
        if (column == 2){keyValue = 7; break;}
        if (column == 3){keyValue = 56; break;}
        if (column == 4){keyValue = 16; break;}
        if (column === 0){keyValue = 0; break;}
        break;
    case 4:
        if (column == 1){keyValue = 6; break;}
        if (column == 2){keyValue = 7; break;}
        if (column == 3){keyValue = 56; break;}
        if (column == 4){keyValue = 48; break;}
        if (column === 0){keyValue = 0; break;}
        break;
    case 5:
        if (column == 1){keyValue = 4; break;}
        if (column == 2){keyValue = 7; break;}
        if (column == 3){keyValue = 56; break;}
        if (column == 4){keyValue = 32; break;}
        if (column === 0){keyValue = 0; break;}
        break;
    default:
        keyValue = 0;
        break;
    }
    if (smsState == "shown"){keyValue = 0;} // no output if showing received SMS
    return keyValue;
}



// Simple mirroring of keys (chords) from side to side (left <-> right)

function mirror(chord) {
                if (chord < 8)
                        return chord * 8;
                else
                        return chord / 8;
}


// state = first key pressed (left or right thumb)
// key = second key pressed  (right or left thumb)

function isOnTheSameSide(status, key){
    var a = (((status < 8) && (key < 8)) || ((status > 7) && (key > 7)));
    if ((status === 0) || (key === 0)){a = false;}
    return a;
}



// When a key is pressed, all symbols on the same side are hidden

function isButtonSymbolHidden(state, key) {
        if (state === 0)
                return false;
        var sameSide = isOnTheSameSide(state, key);
        if (sameSide) {
                return true;
        } else {
                if (isComboButton(key))
                        return true;
        }
        return false;
}



function isMiddleButton(key) {
        switch (key) {
        case 3: // 1 + 3 // O
        case 6: // 2 + 4 // S
        case 40: // 8 + 32 // W
        case 24: // 8 + 16 // G
        case 48: // 16 + 32 // K
        case 5: // 1 + 4 // TH
                return true;
        }
        return false;
}



// Combo keys (extra to the 6 original)

function isComboButton(key) {
        switch (key) {
        case 5: // TH:
        case 40: // 8 + 32: // W:
        case 7: // BACKSPACE:
        case 56: // 8 + 16 + 32: // SPACE:
                return true;
        }
        return false;
}

function mirrorIfOnTheSameSide(state, chord) {
        if (state === 0)
                return chord;

        if ((state < 8 && chord < 8) || (state > 7 && chord > 7)) {
                return mirror(chord);
        } else
                return chord;
}


// Checks that two button presses do not overlap (ie. pressing a with o,
// which already includes a):

function isValidCombination(chord1, chord2) {
                return (chord1 & chord2) === 0;
        }

